# setQRG - Setzt Frequenz und Flags von PLL-ICs MC145156 und MC145158

setQRG setzt Empfangs- und Sendefrequenz, sowie SW1 und SW2 pins eines PLL-ICs wenn vorhanden.

Der anfaengliche Prototyp arbeitet entweder mit einem Dummy-Treiber, der die generierten Daten
auf die Standardausgabe schreibt, oder mit einem Treiber fuer den ODROID-C1 Mikrocomputer, die
neue Version auch mit ORANGE PI ZERO.
Dieser benutzt die GPIO-Pins um ein PLL-IC anzusprechen und die werte zu setzen.

Es werden folgende PLL-Ic's untersttzt: MC145156 und MC145158

Das Programm speichert jeweils die zuletzt eingegebenen Werte JSON-Codiert in einer Textdatei.
Somit muessen bei einem Befehlsaufruf nur die zu aendernden Werte angegeben werden, der Rest 
wird automatisch aus den gespeicherten Daten gelesen.

Wird das Programm ohne Parameter aufgerufen, werden die zuletzt gespeicherten Daten nochmals 
uebertragen.
**Diese Form des Programmaufrufs ist gedacht, beim Start des Systems ausgefuehrt zu werden**


# Waehlbare Parameter

Das Programm ist aktuell dafuer ausgelegt, jeweils 2 PLL-ICs (Rx und Tx) zu beschreiben. 
Deshalb koennen insgesamt 6 Werte angegeben werden:

**--rx** : Empfangsfrequenz
**--tx** : Sendefrequenz
**--sw1_rx** : SW1 vom RX-IC
**--sw2_rx** : SW2 vom RX-IC
**--sw1_tx** : SW1 vom TX-IC
**--sw2_tx** : SW2 vom TX-IC

Die Pins, die zur Ansteuerung der Rx und Tx PLL-ICs genutzt werden, werden im jeweiligen 
Treibermodul angegeben, es kann zwischen **qrg_odroid_gpio.py** und **qrg_orange_gpio.py** 
gewhlt werden.


# Anleitung Einstellungen

Alle entpackten Dateien vom Programm setQRG in den Ordner /opt kopieren z.B. mit WinSCP
In den Ordner /opt wechseln: 

	cd /opt

Datei **setQRG.py** mit einem Texteditor ffnen: 

	nano setQRG.py

Interface auswhlen: **qrg_odroid_gpio** oder **qrg_orange_gpio**
Parameterdatei auswhlen: **MB45_qrgparams** oder **McC_qrgparams**
PLL Ic auswhlen: **mc145156** oder **mc145158**
Schrittgre QRG (kHz): 12.5
Referenzquarz PLL (kHz): 12500 (MB45) oder 14400 (McCompact VHF)
Prescaler Teilwert: 64 (MB45) oder 40 (McCompact VHF)
Erste Zwischenfrequenz RX: 21400

Datei speichern mit 

	Cntl-x

Datei **qrg_orange_gpio.py** oder **qrg_odroid_gpio.py** mit einem Texteditor ffnen: 

	nano qrg_orange_gpio.py

Pinnummer des Kleincomputers fr die Datenleitungen des PLL data, clock, enable RX und 
enable TX zuweisen
Beim Oragne Pi Zero muss die PINNUMMER des 26 Pin Headers und nicht die Nummer des GPIO angegeben
werden, beim Odroid C1 hingegen die GPIO Nummer!

Beispiel fr Orange Pi Zero:
DATA_PIN = 12
CLK_PIN = 13
ENB_RX_PIN = 15
ENB_TX_PIN = 16

Datei speichern mit 

	cntl-x


#Programm **Python** installieren und  **setQRG** compilieren:

	apt-get install python-pip	(compiler installieren)
	pip install Opi.GPIO		(gpio handling fr Orange Pi Zero installieren) **ODER**
	pip install wiringpi2		(gpio handling fr Odroid installieren)
	#!/bin/bash
	python /opt/setQRG.py $@	(compilieren des Programmes, es ensteht das file 
								qrg_orange_gpio.pyc oder qrg_odroid_gpio.pyc)
	cd ..						(in das Hauptverzeichnis wechseln)


#Befehle:

usage: setQRG [-h] [--tx TX] [--rx RX] [--sw1_rx SW1_RX] [--sw2_rx SW2_RX]
              [--sw1_tx SW1_TX] [--sw2_tx SW2_TX] [--txpower TXPOWER]

setQRG - Frequency programming for Motorola MC145156
         PLL Frequency Synthesizer

Copyright (C) 2015, Simon Kofler, IN3FQQ
Licence: GPLv3

optional arguments:
  -h, --help         show this help message and exit
  --tx TX            TX Frequency in kHz
  --rx RX            RX Frequency in kHz
  --sw1_rx SW1_RX    SW1 flag for the RX PLL IC (MC145156 Pin 14)
  --sw2_rx SW2_RX    SW2 flag for the RX PLL IC (MC145156 Pin 15)
  --sw1_tx SW1_TX    SW1 flag for the TX PLL IC (MC145156 Pin 14)
				     RF OUTPUT POWER SETTING for ITALTEL MB-45 (1:high, 0:low)
  --sw2_tx SW2_TX    SW2 flag for the TX PLL IC (MC145156 Pin 15)
  --txpower TXPOWER  RF OUTPUT POWER for MC-Compact (MC145158) (1:high, 0:low)


#Beispiel

	Beschreibung		Befehl

	setQRG Status: 		setQRG
	setQRG help:   		setQRG -h
	QRG setzen (kHz):   setQRG --tx 431400.0 --rx 433025.0
	TX power low:  		setQRG --sw1_tx 0
	TX power high: 		setQRG --sw1_tx 1 
